
#ifndef _GK_SET_UNIFORM_H
#define _GK_SET_UNIFORM_H

#include "Geometry.h"
#include "Transform.h"


namespace gk {

class ProgramName;

//! modifier la valeur d'un uniform du shader program actif, gk::Point.
int setUniform( const ProgramUniform& uniform, const Point& point );
//! modifier la valeur d'un uniform du shader program actif, gk::Point2.
int setUniform( const ProgramUniform& uniform, const Point2& point );

//! modifier la valeur d'un uniform du shader program actif, gk::Vector.
int setUniform( const ProgramUniform& uniform, const Vector& vector );
//! modifier la valeur d'un uniform du shader program actif, gk::Normal.
int setUniform( const ProgramUniform& uniform, const Normal& vector );

//! modifier la valeur d'un uniform du shader program actif, gk::Color.
int setUniform( const ProgramUniform& uniform, const Color& color);

//! modifier la valeur d'un uniform du shader program actif, gk::Transform.
int setUniform( const ProgramUniform& uniform, const Transform& transform );
//! modifier la valeur d'un uniform du shader program actif, gk::Matrix4x4.
int setUniform( const ProgramUniform& uniform, const Matrix4x4& transform );

}       // namespace

#endif
